
/*  CPU_SPEED for GP2X
    Copyright (C) 2005  Hermes/PS2Reality 
	Modified by Vimacs
	Hacked apart for a800 by foft

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

#include "cpuctrl.h"
#include <stdio.h>
#include <stdlib.h>

static unsigned int sysfreq=200;
static unsigned int sysm=0;

void initSpeed()
{
	cpuctrl_init();  // ATENCION: si no se hace esto, cuelgue seguro (aprovecho la definicion de rlyeh y debe ir despues de gp2x_init)
	Disable_940(); // desconecta el 940t

	sysfreq = get_freq_920_CLK()/1000000;

	fprintf(stderr,"initSpeed CLK:%d DIV:%d\n", sysfreq, sysm);
}

void setSpeed(int frequency, int m)
{
	//unsigned lfreq[15]={60,66,80,100,120,133,150,166,200,210,220,240,250,266,280}; // por encima de 220 MHz solo funciona con div 1
	//Guessing these are known good ones
	fprintf(stderr,"setSpeed to %d:%d\n", frequency, m);
	
	// frequency/(m+1)
	set_FCLK(frequency);
	set_920_Div(m);
	set_940_Div(m);
	set_DCLK_Div(m); 

	// log new
	fprintf(stderr,"now:%dMHz\n",get_freq_920_CLK()/1000000);
}

void replaceSpeed()
{
	setSpeed(sysfreq, sysm);
}

