#include "menu_amenu.h"

#include <string>
#include <deque>

class AKeyMenu:
	public AMenu
{
	int d_key;
	int d_oper;
	int d_consol;
	int d_shift;
	int d_joy;

	bool d_immediate;
	bool d_pressedLast;

public:
	AKeyMenu(int driver, const std::deque<std::string> & tokens, bool immediate=true);

	virtual std::string type()
	{ return "Key";}

	virtual void frame(int keysPressed);
	virtual void clean();

private:
	void press();
	void unpress();
};

