/* $Id: log.c,v 1.4 2002/04/07 05:44:47 vasyl Exp $ */
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "config.h"
#include "log.h"

#define MAX_LOG_SIZE		1024*500
char * memory_log = 0;
char * memory_log_ptr = 0;

static FILE * file = (FILE *)-1;

#define SYNCHRONOUS_LOG
//#define BUFFERED_LOG

void Aprint(char *format, ... )
{
	return;
	va_list args;
	char buffer[256];
#ifdef BUFFERED_LOG
	int buflen;
	if (memory_log == 0)
	{
		memory_log = (char *)malloc(MAX_LOG_SIZE);
		memory_log_ptr = memory_log;
	}
#endif

	va_start(args, format);
	vsprintf(buffer, format, args);
	va_end(args);

#ifdef BUFFERED_LOG
	buflen = strlen(buffer);

	if ((memory_log_ptr - memory_log + buflen + 1) > MAX_LOG_SIZE)
		memory_log_ptr = memory_log;

	memcpy(memory_log_ptr, buffer, buflen);
	memory_log_ptr += buflen;
#else
	if (file == -1)
	{
		file = fopen("/mnt/sd/a800.log", "w");
	}
	fprintf(file, "%s\n", buffer);
#endif

#ifdef SYNCHRONOUS_LOG
	Aflushlog();
#endif

}

void Aflushlog(void)
{
#ifdef BUFFERED_LOG
	if (*memory_log) {
		if (file == -1)
		{
			file = fopen("/mnt/sd/a800.log", "w");
		}
		*(memory_log_ptr+1) = 0;
		fprintf(file, memory_log);
		memory_log_ptr = memory_log;
	}
#endif
	fflush(file);
	fclose(file);
	file = fopen("/mnt/sd/a800.log", "a");
}

/*
$Log: log.c,v $
Revision 1.4  2002/04/07 05:44:47  vasyl
Log buffer is completely hidden inside C file (no extern in header). This allows
log-less ports to save extra 8K.

Revision 1.3  2001/12/04 14:17:52  joy
Aflushlog() should be always available though it does nothing when BUFFERED_LOG is undefined

Revision 1.2  2001/03/18 06:34:58  knik
WIN32 conditionals removed

*/
